package de.hdm_stuttgart.mi.sd1.figure.model;

/**
 * @author goik
 *
 */
public abstract class Figure {
     
   private double x,y;
   
   /**
    * Creating a figure with given center coordinates
    *  
    * @param x
    * @param y
    */
   public Figure(double x, double y) {
      setX(x);
      setY(y);
   }
   
   // To be implemented in derived classes Rectangle and Circle
   /**
    * 
    * @return The current figure's area e.g. with times height in case of a rectangle
    */
   public abstract double getArea();
   
   /**
    * @return The current figure's perimeter e.g. with 2 * (height + width) in case of a rectangle
    */
   public abstract double getPerimeter();
   
   public double getX() { return x;}
   public void setX(double x) { this.x = x;}
   public double getY() { return y;}
   public void setY(double y) { this.y = y;}
   
   /**
    * Translating a figure by a given vector (x,y).
    * 
    * @param x
    * @param y
    * @return The current object.
    */
   public final Figure move(double x, double y) {
      setX(getX() + x);
      setY(getY() + y);
      return this;
   }
}